// package JavaCode;

import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataOutputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.Iterator;
import java.util.Random;
import java.util.StringTokenizer;

import com.sun.org.apache.xalan.internal.xsltc.runtime.Hashtable;

public class CreateDB2Ob {
	private class Sequencability {
		byte[] C_map;
		public Sequencability(int size) {
			C_map = new byte[size];
    		for (int j = 0; j < size; j++) {
    			C_map[j] = 0;
    		}
 		}
	}
	private class Test implements Runnable {
		int chr = 0; 
		boolean paralell = true;
		public void run() { // int chr, boolean paralel
			increment();
			int x = Math.abs(generator.nextInt() % 30);
			System.err.println("Chr:\t" + chr + "\t" + x);
			try {
				Thread.sleep(1000 * x);
			} catch(Exception e) {
				
			}
			decrement();
		}
	}
	private class CreateOligoFile implements Runnable {
		int chr = 0; 
		Seq   seq;
		Oligo ol;
		boolean paralell = true;
		public CreateOligoFile() {
		}
		public CreateOligoFile(int chr) {
			this.chr = chr;
		}
		public void run() { // int chr, boolean paralell
			int ok;
			int id = Parameters.maxId;
			int totalIn = 0;
			int totalOut = 0;
			boolean uq;
			boolean fd;
			Iterator<Oligo> it;
			Oligo.sortIndex = Oligo.SEQ;
			OligoFile outOligoFile;
			String outOlFile;
			if (paralell) {
				outOlFile = Parameters.pathDB + Parameters.DATABASE + Parameters.outFile + ".db." + chr;			
			} else {
				outOlFile = Parameters.pathDB + Parameters.DATABASE;
			}
			System.err.println(outOlFile);
			try {
				outOligoFile = new OligoFile(outOlFile, "", OligoFile.W);
			} catch (Exception e) {
				outOligoFile = null;
			}
			seq = new Seq();
			seq.prbSize = Parameters.dbOligoSize; //Parameters.seedSize;
			seq.size = Parameters.seedSize;
			for (int i = 0; i < prb[chr].size - seq.prbSize; i++) {
				fd = true;
				loadSeq(chr, i, fd);
				try {
					ok = seq.solvePrbLineDB(0);
				} catch (Exception e) {
					ok = -1;
				}
				totalIn++;
				uq = false;
				if (ok >= 0) {
					try {
						seq.getPS();  // equal sizes for now
					} catch (Exception e) {
					}

					if (ok == 0)
						uq = true;
					else 
						uq = false;
				} else {
					continue;
				}
				it = seq.bunk.iterator();
				while (it.hasNext()) {
					ol = (Oligo) it.next ();
					ol.setUQ(uq);
					ol.setLQ(false);
					ol.setRC(false);
					ol.ch  = (byte) chr;
					ol.id1 = id;
					ol.start = i;
					ol.setSide(0);
					try {
						outOligoFile.sort_WriteOligo(new Oligo(ol), Oligo.SEQ);
					} catch (Exception e) {
					}

					totalOut++;
				}
				fd = false;
				// System.err.println("Loading seq: " + i + " Backward");
				loadSeq(chr, i, fd);
				// System.err.println("Loading seq: " + i + " Backward");
				try {
					ok = seq.solvePrbLineDB(0);
				} catch (Exception e) {
				}

				// System.err.println("Solved: " + ok);
				uq = false;
				if (ok >= 0) {
					try {
						seq.getPS();  // equal sizes for now
					} catch (Exception e) {
					}

					if (ok == 0)
						uq = true;
					else 
						uq = false;
				} else {
					continue;
				}
				it = seq.bunk.iterator();
				while (it.hasNext()) {
					ol = (Oligo) it.next ();
					ol.setUQ(uq);
					ol.setLQ(false);
					ol.setRC(true);
					ol.ch  = (byte) chr;
					ol.id1 = id;
					ol.start = i;
					ol.setSide(0);
					try {
						outOligoFile.sort_WriteOligo(new Oligo(ol), Oligo.SEQ);
					} catch (Exception e) {
					}
					totalOut++;
				}
				id--;
			}
			Oligo.sortIndex = Oligo.SEQ;
			try {
				outOligoFile.saveSBunk(Oligo.SEQ);
				outOligoFile.minID = id;
				outOligoFile.dfn = outOligoFile.dfns;
				outOligoFile.close();
			} catch (Exception e) {
			}
			// BufferedReader reader = new BufferedReader(new FileReader(Parameters.pathRefSeq + prb[chr].name));
			try {
				float[] ref_p = {0, 0, 0, 0};
				float sum;
				int[] mx = {0, 0, 0, 0};
				int nx;
				System.err.println("\n" + Parameters.pathDB + Parameters.DATABASE + prb[chr].name + ".pRef");
				DataOutputStream dos = new DataOutputStream(new BufferedOutputStream(new 
						FileOutputStream(Parameters.pathDB + Parameters.DATABASE + prb[chr].name + ".pRef"), Parameters.buffSize));
				for (int i = 0; i < prb[chr].size; i++) {
					sum = 0;
					for (int b = 0; b < 4; b++) {
						ref_p[b] = ((float) prb[chr].pByte[b][i]) / 100 + Parameters.snpRatio / 3;
						sum += ref_p[b];
					}
					for (int b = 0; b < 4; b++) {
						ref_p[b] = ref_p[b] / sum;
					}
					if (ref_p[0] >= ref_p[1]) {
						mx[0] = 0;
						mx[1] = 1;
					} else {
						mx[0] = 1;
						mx[1] = 0;
					}
					nx = 2;
					for (int b = 2; b < 4; b++) {
						if (ref_p[b] > ref_p[mx[1]]) {
							mx[nx] = mx[1];
							if (ref_p[b] > ref_p[mx[0]]) {
								mx[1]  = mx[0];
								mx[0]  = b;
							} else {
								mx[1]  = b;
							}
						} else {
							mx[nx] = b;
						}
						nx++;
					}
					if (ref_p[mx[2]] < ref_p[mx[3]]) {
						nx    = mx[2];
						mx[2] = mx[3];
						mx[3] = nx;
					}
					dos.writeByte((byte) mx[0]);
					dos.writeByte((byte) mx[1]);
					dos.writeByte((byte) mx[2]);
					dos.writeByte((byte) mx[3]);
					for (int b = 0; b < 4; b++) {
						dos.writeFloat(ref_p[b]);
					}
				}
				dos.close();
				/*
				try {
					DataInputStream dis = new DataInputStream(new BufferedInputStream(new 
							FileInputStream(Parameters.pathDB + Parameters.DATABASE + prb[chr].name + ".pRef"), Parameters.buffSize));
					// System.err.println("----------------------> Open:\t" + Parameters.pathDB + Parameters.DATABASE + prb[chr].name + ".pRef");
					for (int j = 0; j < 100000; j++) {
						// System.err.println("XXX");
						if(dis.available() > 0) {
							// System.err.println("-------------" + j);
							mx[0] = dis.readByte();
							mx[1] = dis.readByte();
							mx[2] = dis.readByte();
							mx[3] = dis.readByte();
							for (int b = 0; b < 4; b++) {
								ref_p[b] = dis.readFloat();
							}
							if (ref_p[mx[0]] < ref_p[mx[1]]) // prb[chr].pByte[1][i]
								System.err.print(mx[0] + "\t" + mx[1] + "\t" + mx[2] + "\t" + mx[3] + "\t" + 
										ref_p[0] + "\t" + ref_p[1] + "\t" + ref_p[2] + "\t" + ref_p[3]);
								System.err.println("\t" + 
										prb[chr].pByte[0][j] + "\t" + prb[chr].pByte[1][j] + "\t" + prb[chr].pByte[2][j] + "\t" + prb[chr].pByte[3][j]);
						} else {
							System.err.println("----------------------> Total:\t" + j);
							break;
						}
					}
					System.err.println("----------------------> Close:\t" + Parameters.pathDB + Parameters.DATABASE + prb[chr].name + ".pRef");
					Thread.sleep(2000);
					dis.close();
				} catch (Exception e) {
					System.err.println(Parameters.pathDB + Parameters.DATABASE + prb[chr].name + ".pRef file Error ------------");
				}
//*/
			} catch (Exception e) {
			}
		}
		private void loadSeq(int chr, int start, boolean fd) {
			int b;
			if (fd) {
				for (int is = 0; is < seq.size; is++) {
					for (int js = 0; js < 4; js++) {
						seq.p[is][js] = ((float) prb[chr].pByte[js][start + is]) / 100;
					}
				}
				for (int is = seq.size; is < seq.prbSize; is++) {
					b = prb[chr].b[start + is];
					if (b < 0 || b > 4) {
						b = 4;
					}
					seq.ps[is] = Oligo.nucl[b];
				}
			} else {
				for (int is = 0; is < seq.size; is++) {
					for (int js = 0; js < 4; js++) {
						seq.p[is][js] = ((float) prb[chr].pByte[Oligo.baseComp((short) js)]  [start + seq.prbSize - is - 1]) / 100;
					}
				}
				for (int is = seq.size; is < seq.prbSize; is++) {
					b = prb[chr].b[start + seq.prbSize - is - 1];
					if (b < 0 || b > 4 ) {
						b = 4;
					} else {
						b = Oligo.baseComp((short) b);
					}
					seq.ps[is] = Oligo.nucl[b];
				}	
			}
		}
		public void generateDbOligosFromPRB(int chr, int clusterSize) throws Exception {
			OligoFile outOligoFile;
			int  id   = Parameters.maxId;
			int  idQc = 0;
			boolean  used = false;
			int rd;
			long totalIn  = 0;
			long totalOut = 0;
			long totalMPS = 0;
			long totalCrisp  = 0;
			boolean mps = false;
			boolean uq  = false;
			int  ok;
			String outOlFile;
			seq = new Seq();
			if (clusterSize == 0) {
				outOlFile = Parameters.pathDB + Parameters.dbname;
			} else {
				outOlFile = Parameters.pathDB + Parameters.dbname + Parameters.outFile + "." + chr + ".db";			
			}
			outOligoFile = new OligoFile(outOlFile, "", OligoFile.W);

			for (int i = 0; i < prb[chr].size - seq.size; i++) {
				seq.size = Parameters.seedSize;
				seq.prbSize = Parameters.seedSize;
				for (int is = 0; is < seq.prbSize; is++) {
					for (int js = 0; js < 4; js++) {
						seq.p[is][js] = ((float) prb[chr].pByte[js][i + is]) / 100;
					}
				}
				ok = seq.solvePrbLineDB(0);
				totalIn++;
				uq = false;
				if (ok >= 0) {
					seq.getPS();  // equal sizes for now
					uq = true;
				} else {
					continue;
				}
				Iterator<Oligo> it = seq.bunk.iterator();
				rd = 0;
				mps = true;
				while (it.hasNext()) {
					if (rd > Parameters.maxMu) {
						break;
					} 	    							
					ol = (Oligo) it.next ();

					ol.setMP(mps);
					ol.setUQ(uq);
					ol.setLQ(false);
					mps = false;
					ol.id1 = id;
					ol.setSide(0);
					outOligoFile.sort_WriteOligo(new Oligo(ol), Oligo.SEQ);
					used = true;
					totalOut++;

					rd++;
				}
				if (used) {
					id--; // ++
					totalMPS++;
					if(uq)
						totalCrisp++;
				} else {
					idQc++;
				}
				used = false;
			}
			Oligo.sortIndex = Oligo.SEQ;
			outOligoFile.saveSBunk(Oligo.SEQ);
			outOligoFile.minID = id;
			outOligoFile.dfn = outOligoFile.dfns;
			outOligoFile.close();
			outOligoFile = new OligoFile(outOlFile, "", OligoFile.R);
			outOligoFile.joinSort();

			outOligoFile.close();
		    System.out.println(
		    		"\nTotal lines .....................:\t" + totalIn + 
		    		"\nNumber of MPS only lines ........:\t" + totalMPS + 
		    		"\nNumber of UQ lines ..............:\t" + totalCrisp +
		    		"\nFinal number of Oligos ..........:\t" + totalOut +
		    		"\nMultiplication ratio of UD Oligos:\t" + ((float) (totalOut - totalCrisp) / (float) (Parameters.maxId - id - (totalCrisp)))
		    		);
		  //*/

		}

	}
	private class Contig {
		public int chr;
		public int offset;
		public Contig() {
			chr = 0;
			offset = 0;
		}
		public Contig(int ch, int l) {
			chr = ch;
			offset = l;
		}
	}
	private class RefSeq {
		public int size;
		public String name;
		public byte[][] pByte;
		public byte[]   b;
		public RefSeq() {
			
		}
		public RefSeq(int chr) {
			name = new String(Parameters.ch_name1 + Parameters.SEQ_VAR[chr] + Parameters.ch_name2);
			System.err.println("Creating RefSeq:\t" + name + "\t" + size);
		}
		public void init(int sz) {
			size = sz;
			pByte = new byte[4][size];
			b     = new byte[size];
		}
	}
	
	RefSeq[] prb;
	Hashtable ht;
	long  countSNPs;
	long  genomeSize;
	float snps_Ratio;
	Random generator;
	int countThreads = 0;
	public synchronized void increment() {
		countThreads++;
	}
    public synchronized void decrement() {
    	countThreads--;
    }


	public CreateDB2Ob() throws Exception {
		//*
		countSNPs  = 0;
		genomeSize = 0;
		ht = new Hashtable(200);
		prb = new RefSeq[Parameters.SEQ_VAR.length]; // float[refSize][4];
		BufferedWriter writer = new BufferedWriter(new FileWriter(Parameters.pathDB + Parameters.DATABASE + "refSeqSizes"));
		CreateOligoFile[] of = new CreateOligoFile[Parameters.SEQ_VAR.length];
		System.err.println("Total " + Parameters.pathDB + "\tgenome size is: " + genomeSize);
		for (int chr = 0; chr < Parameters.SEQ_VAR.length; chr++) {
			countSNPs = 0;
			prb[chr] = new RefSeq(chr);
			scanRef(chr);
			genomeSize += prb[chr].size;
			writer.write(prb[chr].size + "\n");
			// loadSNPs1(chr);
			loadSNPs1(chr);
			loadSeqData(chr);
			of[chr] = new CreateOligoFile(chr);
			of[chr].run();
			prb[chr].pByte = null;
			prb[chr].b     = null;
			System.gc();
		}
		writer.close();
		try {
			System.err.println("join 1");
			OligoFile outOligoFile = new OligoFile();
			System.err.println("join 2");
			outOligoFile.joinSortU2DB();
			System.err.println("join 3");
			outOligoFile.close();
			System.err.println("join 4");
		} catch (Exception e) {
			System.err.println("join E\t" + Parameters.pathDB + Parameters.DATABASE + "\n" + e);			
		}
		//*/
	}

	public int getRefSize(int chr) {
		return prb[chr].size;
	}
	
	private void scanRef(int chr) throws Exception {
		BufferedReader reader = new BufferedReader(new FileReader(Parameters.pathRefSeq + prb[chr].name));
		BufferedWriter writer = new BufferedWriter(new FileWriter(Parameters.pathDB + Parameters.DATABASE + prb[chr].name + ".contigs"));
		System.err.print("CreateDB2Ob:scanRef, reads " + Parameters.pathRefSeq + prb[chr].name + " create '.contigs'");
		int refSize = 0;
		String line = null;
		// String tk = null;
		while(reader.ready()) {
			line = reader.readLine();
			if (line.length() > 0) {
				// System.err.println("line>\t" + line + "\t" + line.length());
				if (line.charAt(0) != '>' && line.length() > 0) {
					refSize += line.length();
				} else {
					writer.write(refSize + "\t>" + line + "\n");
					ht.put(Parameters.SEQ_VAR[chr], new Contig(chr, refSize));
				}
			}
		}
		// refSize += 50;
		prb[chr].init(refSize);
		System.err.println("\tsize:\t" + prb[chr].size);
		writer.close();
		reader.close();
	}
	
	private void loadSNPsDb(int cht) throws Exception {
		int ch = 0;
		int bs;
		int ofst = 0;
		// int countSNPs = 0;
		boolean basesOK = true;
		String stCh;
		String stOfst;
		int    strand = 1;
		String strd;
		String bases = null;
		Contig itg;
		int countTokens;
		try{
			BufferedReader reader = new BufferedReader(new FileReader(Parameters.pathRefSeq + "SNPs"));
			System.err.print("Loading SNPs from:\t" + Parameters.pathRefSeq + "SNPs");
			StringTokenizer st;
			String line = null;
			while(reader.ready()) {
				line = reader.readLine();
				// System.err.println(line);
				st = new StringTokenizer(line);
				countTokens = st.countTokens(); 
				if (countTokens > 5) {
					st.nextToken();
					stCh   = st.nextToken();
					stOfst = st.nextToken();
					strd   = st.nextToken();
					try {
						strand = new Integer(strd).intValue();
						bases  = st.nextToken();
						basesOK = true;
						for (int i = 1; i < bases.length(); i += 2) {
							if (bases.charAt(i) == '/' && bases.charAt(i-1) != '-') {
								basesOK = true;
							} else {
								basesOK = false;
								break;
							}
						}
						if (basesOK && bases.charAt(bases.length()-1) != '-') {
							basesOK = true;
						} else {
							basesOK = false;
						}
						if (basesOK) {
							if (Character.isDigit(stCh.charAt(0))) {
								ch   = new Integer(stCh).intValue() - 1;
								ofst = 0;
							} else {
								itg = (Contig) ht.get(stCh); // ============================
								if (itg != null) {
									ch   = itg.chr;
									ofst = itg.offset;
								} else {
									continue;
								}
							}
							ofst += new Integer(stOfst).intValue() -1;
							//*
							// System.err.print(ch + "\t" + ofst);
							if (ch >= 0 && ch < Parameters.SEQ_VAR.length && ch == cht) {
								for (int i = 0; i < bases.length(); i += 2) {
									bs = Oligo.getBpInt(Character.toUpperCase(bases.charAt(i)), strand);
									if (bs >= 0) {
										prb[ch].pByte[bs][ofst] = 100;
									}
								}
								/*
								System.err.print(Parameters.SEQ_VAR[ch] + "\t" + ofst + "\t:" );
								for (int b = 0; b < 4; b++) {
									System.err.print("\t" + prb[ch].p[b][ofst]);
								}
								System.err.println("\n");
								Thread.sleep(1000);
								//*/
							}
						}
					} catch(Exception e) {
						// System.err.println(strd);
						strand = 1;
					}
				}
			}
			// for (int chr = 0; chr < Parameters.SEQ_VAR.length; chr++) { // SEQ_VAR.length
				for (int i = 0; i < prb[cht].size; i++) {
					if ((prb[cht].pByte[0][i] + prb[cht].pByte[1][i] + prb[cht].pByte[2][i] + prb[cht].pByte[3][i]) > 0) {
						countSNPs++;					
					}
				}
			// }
			reader.close();
		} catch (Exception e) {
			System.err.println("No known SNPs file found");
		}
	}

	private void loadSNPs1(int cht) throws Exception {
		int ch = 0;
		int bs;
		int ofst = 0;
		// int countSNPs = 0;
		boolean basesOK = true;
		String stCh;
		String stOfst;
		int    strand = 1;
		String strd;
		String bases = null;
		Contig itg;
		int countTokens;
		try{
			BufferedReader reader = new BufferedReader(new FileReader(Parameters.pathKnownSNPs + "SNPs"));
			System.err.print("Loading SNPs from:\t" + Parameters.pathRefSeq + "SNPs");
			StringTokenizer st;
			String line = null;
			while(reader.ready()) {
				line = reader.readLine();
				// System.err.println(line);
				st = new StringTokenizer(line);
				countTokens = st.countTokens(); 
				if (countTokens > 3) {
					st.nextToken();
					stCh   = st.nextToken();
					stOfst = st.nextToken();
					strd   = st.nextToken();
					try {
						strand = new Integer(strd).intValue();
						bases  = st.nextToken();
						basesOK = true;
						for (int i = 1; i < bases.length(); i += 2) {
							if (bases.charAt(i) == '/' && bases.charAt(i-1) != '-') {
								basesOK = true;
							} else {
								basesOK = false;
								break;
							}
						}
						if (basesOK && bases.charAt(bases.length()-1) != '-') {
							basesOK = true;
						} else {
							basesOK = false;
						}
						if (basesOK) {
							if (Character.isDigit(stCh.charAt(0))) {
								ch   = new Integer(stCh).intValue() - 1;
								ofst = 0;
							} else {
								itg = (Contig) ht.get(stCh); // ============================
								if (itg != null) {
									ch   = itg.chr;
									ofst = itg.offset;
								} else {
									continue;
								}
							}
							ofst += new Integer(stOfst).intValue() -1;
							//*
							// System.err.print(ch + "\t" + ofst);
							if (ch >= 0 && ch < Parameters.SEQ_VAR.length && ch == cht) {
								for (int i = 0; i < bases.length(); i += 2) {
									bs = Oligo.getBpInt(Character.toUpperCase(bases.charAt(i)), strand);
									if (bs >= 0) {
										prb[ch].pByte[bs][ofst] = 100;
									}
								}
								/*
								System.err.print(Parameters.SEQ_VAR[ch] + "\t" + ofst + "\t:" );
								for (int b = 0; b < 4; b++) {
									System.err.print("\t" + prb[ch].p[b][ofst]);
								}
								System.err.println("\n");
								Thread.sleep(1000);
								//*/
							}
						}
					} catch(Exception e) {
						// System.err.println(strd);
						strand = 1;
					}
				}
			}
			// for (int chr = 0; chr < Parameters.SEQ_VAR.length; chr++) { // SEQ_VAR.length
				for (int i = 0; i < prb[cht].size; i++) {
					if ((prb[cht].pByte[0][i] + prb[cht].pByte[1][i] + prb[cht].pByte[2][i] + prb[cht].pByte[3][i]) > 0) {
						countSNPs++;					
					}
				}
			// }
			reader.close();
		} catch (Exception e) {
			System.err.println("No known SNPs file found");
		}
	}	
	
	private void loadSeqData(int chr) throws Exception {
		System.err.print("Loading reference sequence for:\t" + prb[chr].name);
		int bs;
		String line;
		int cntBases;
		int cntNs = 0;
		byte pSnp;
		byte sum;
		int counter = 0;
		int countNM = 0;
		int countM  = 0;
		BufferedReader reader = new BufferedReader(new FileReader(Parameters.pathRefSeq + prb[chr].name));
		line = null;
		while(reader.ready()) {
			line = reader.readLine();
			if (line.length() > 0) {
				// System.err.println(line);
				if (line.charAt(0) != '>') {
					// System.err.println("Loading");
					for (int i = 0; i < line.length(); i++) {
						bs = Oligo.getBpInt(Character.toUpperCase(line.charAt(i)));
						prb[chr].b[counter] = (byte) bs;
						cntBases = 0;
						for (int b = 0; b < 4; b++) {
							if (prb[chr].pByte[b][counter] > 0) {
								cntBases++;
							}
						}
						if (bs >= 0) {
							if (cntBases > 1) {
								pSnp = 10; 
								sum = 0;
								if (prb[chr].pByte[bs][counter] == 0) {
									countNM++;
									for (int b = 0; b < 4; b++) {
										prb[chr].pByte[b][counter] = 0;
									}
									prb[chr].pByte[bs][counter] = 100;
								} else {
									countM++;
									for (int b = 0; b < 4; b++) {
										if (prb[chr].pByte[b][counter] > 0) {
											prb[chr].pByte[b][counter] = pSnp;
											sum += pSnp;
										}
									}
									prb[chr].pByte[bs][counter] = (byte) (100 - sum);
								}
								/*
								if (prb[chr].pByte[bs][i] == Parameters.snpWeight) {
									countNM++;
								} else if (prb[chr].pByte[bs][i] > Parameters.snpWeight) {
									countM++;
								}
								//*/
							} else {
								for (int b = 0; b < 4; b++) {
									prb[chr].pByte[b][counter] = 0;
								}
								prb[chr].pByte[bs][counter] = 100;
							}
						} else {
							cntNs++;
							for (int b = 0; b < 4; b++) {
								prb[chr].pByte[b][counter] = (byte) 25;
							}						
						}
						counter++;
					}
				} 
			}
		}
		reader.close();
		System.err.println("\tCount Not Match:\t" + countNM + "\tCount Match:\t" + countM + "\tCount Ns:\t" + cntNs);
	} 
	
    public  void dbChart() throws Exception {
    	long count = 0;
    	Oligo ol = new Oligo();
    	float[] fHist = new float[Parameters.dbHistSize];
    	long[][] hist = new long[2][Parameters.dbHistSize];
    	for (int i = 0; i < Parameters.dbHistSize; i++) {
    		hist[0][i] = hist[1][i] = 0;
    		fHist[i] = 0;
    	}
    	System.err.println(Parameters.pathDB + Parameters.DATABASE);
    	OligoFile ofile = new OligoFile(Parameters.pathDB + Parameters.DATABASE, "", OligoFile.R);
  		while(ofile.readOligo(ol)) {
  			count++;
  			if (count % 10000000 == 0)
  				System.err.println(count/1000000 + "M");
  			if (ol.u0 < Parameters.dbHistSize) {
  				hist[0][ol.u0]++;
  			} else if (ol.u0 >= Parameters.dbHistSize) {
  				hist[0][Parameters.dbHistSize-1]++;
  			} else {
  				System.err.println("Error in dbChart:\t" + ol);
  			}
  		}
		ofile.close();
		System.err.println(Parameters.pathDB + Parameters.DATABASE + "/dbHist.txt");
    	BufferedWriter writer = new BufferedWriter(new FileWriter(Parameters.pathDB + Parameters.DATABASE + "/dbHist.txt"));
    	for (int i = 1; i < Parameters.dbHistSize; i++) {
    		hist[1][i] = hist[0][i] + hist[1][i-1];
    		fHist[i] = (float) ((double) hist[1][i] / count);
    	}
    	for (int i = 0; i < Parameters.dbHistSize; i++) {
    		writer.write((i + 1) + "\t" + hist[0][i] + "\t" + hist[1][i] + "\t" + fHist[i] + "\n");
    	}
    	writer.close();
    }

    public  void sequencability(int sz) throws Exception {
    	long ofidx = 0;
    	Oligo ol = new Oligo();
    	Sequencability[] sq = new Sequencability[Parameters.SEQ_VAR.length];
		int[] refSeqSize = new int[Parameters.SEQ_VAR.length];
		getRefSeqSize(Parameters.pathDB + Parameters.DATABASE, refSeqSize);

    	for (int i = 0; i < Parameters.SEQ_VAR.length; i++) {
    		// System.err.println(prb[i].name + " Size:\t" + prb[i].size);
    		sq[i] = new Sequencability(refSeqSize[i]);
    	}
    	long[] histo   = new long[2 * sz + 1];
		for (int j = 0; j < histo.length; j++)
			histo[j] = 0;
		ofidx = 0;
    	OligoFile ofile = new OligoFile(Parameters.pathDB + Parameters.DATABASE, "", OligoFile.R);
  		System.err.println("SZ:\t" + sz + "\tParameters.dbOligoSize\t" + Parameters.dbOligoSize);
  		while(ofile.readOligo(ol)) { // ------------------------------------------------------
   			ofidx++;
   			if (ofidx % 100000000 == 0)
   				System.err.println("\t" + (ofidx/100000000) + "00,000,000");
   			if(ol.start + Parameters.dbOligoSize > sq[ol.ch].C_map.length) {
   				System.err.println("Read location is out:\t" + ol.ch + "\t" + ol.start);
   			}
   			//*
			if(ol.u0 < sz) {
				if (ol.isRC()) {
					for (int i = 0; i < sz; i++) {
						if (sq[ol.ch].C_map[ol.start + Parameters.dbOligoSize - i - 1] < ( 2 * sz))
							sq[ol.ch].C_map[ol.start + Parameters.dbOligoSize - i - 1] += (byte) ol.weight;
					}
				} else {
					for (int i = 0; i < sz; i++) {
						if (sq[ol.ch].C_map[ol.start + i] < ( 2 * sz))
							sq[ol.ch].C_map[ol.start + i] += (byte) ol.weight;
					}
				}
			}
			//*/
		}		
		for (int ifile = 0; ifile < Parameters.SEQ_VAR.length; ifile++) {
			for (int j = 0; j < refSeqSize[ifile]; j++) {
				if (sq[ifile].C_map[j] > ( 2 * sz)) {
					System.err.println("i0\t" + sq[ifile].C_map[j] + ",\tchr\t" + ifile + "\tidx\t" + j);
				} else {
					histo[sq[ifile].C_map[j]]++;
				}
			}
		}
		
		ofile.close();	
		// ----------------------------------------------------------------------- Writing Results
		for (int ifile = 0; ifile < Parameters.SEQ_VAR.length; ifile++) {
			// System.err.println("\nWriting map to:\t" + Parameters.pathDB + Parameters.DATABASE + prb[ifile].name + ".map." + sz);
			FileOutputStream     fwOne = new FileOutputStream(Parameters.pathDB + Parameters.DATABASE + Parameters.ch_name1 + Parameters.SEQ_VAR[ifile] + Parameters.ch_name2 + ".map." + sz);
			BufferedOutputStream bwOne = new BufferedOutputStream(fwOne);
			DataOutputStream     file  = new DataOutputStream(bwOne);			
			for (int i = 0; i < refSeqSize[ifile]; i++) {
				file.writeByte(sq[ifile].C_map[i]);
			}
		    file.close();
		    bwOne.close();
		    fwOne.close();
	 	}
		sq = null;
		System.gc();
		/*
		System.out.println("sequencability\t# of Noclutides");
		for (int i = 0; i < histo.length; i++) {
			System.out.println("\t" + i + "\t" + histo[i]);
		}
		//*/
    }

    public  void sequencability0() throws Exception {
    	long ofidx = 0;
    	Oligo ol = new Oligo();
    	Sequencability[] sq = new Sequencability[Parameters.SEQ_VAR.length];
		int[] refSeqSize = new int[Parameters.SEQ_VAR.length];
		getRefSeqSize(Parameters.pathDB + Parameters.DATABASE, refSeqSize);

    	for (int chr = 0; chr < Parameters.SEQ_VAR.length; chr++) {
    		sq[chr] = new Sequencability(refSeqSize[chr]);
    	}
		ofidx = 0;
    	OligoFile ofile = new OligoFile(Parameters.pathDB + Parameters.DATABASE, "", OligoFile.R);
  		while(ofile.readOligo(ol)) { // ------------------------------------------------------
   			ofidx++;
   			if (ofidx % 100000000 == 0)
   				System.err.println("\t" + (ofidx/100000000) + "00,000,000");
   			if(ol.start + Parameters.dbOligoSize > sq[ol.ch].C_map.length) {
   				System.err.println("Read location is out:\t" + ol.ch + "\t" + ol.start);
   			}
			if (!ol.isRC()) {
				// sq[ol.ch].C_map[ol.start + Parameters.dbOligoSize - 1] = ol.u0;
				sq[ol.ch].C_map[ol.start] = ol.u0;
			}
		}		
		
		ofile.close();	
		String fl;
		// ----------------------------------------------------------------------- Writing Results
		for (int ifile = 0; ifile < Parameters.SEQ_VAR.length; ifile++) {
			fl = Parameters.pathDB + Parameters.DATABASE + Parameters.ch_name1 + Parameters.SEQ_VAR[ifile] + Parameters.ch_name2 + ".map0";
			DataOutputStream     file  = new DataOutputStream(new BufferedOutputStream(new FileOutputStream(fl)));			
			for (int i = 0; i < refSeqSize[ifile]; i++) {
				file.writeByte(sq[ifile].C_map[i]);
			}
		    file.close();
	 	}
		sq = null;
		System.gc();
    }

	static void getRefSeqSize(String dbfile, int[] refSeqSize) throws Exception {
		String line;
		StringTokenizer tokens;
		// rs.refSeqSize = new int[refSeqSize.length];
		System.err.println(dbfile + "refSeqSizes");
		BufferedReader reader = new BufferedReader(new FileReader(dbfile + "refSeqSizes"));
		for (int i = 0; i < refSeqSize.length; i++) {
			System.err.print(i + "\tSize:\t");
			line           = reader.readLine();
			System.err.println("dbfile\t" + line);
			tokens         = new StringTokenizer(line);	
			refSeqSize[i]      = new Integer(tokens.nextToken());
			// System.err.println(refSeqSize[i]);
		}
	}
}
