// package JavaCode;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.InputStreamReader;
import java.util.zip.GZIPInputStream;

public class fastq {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		BufferedReader[] reader = new BufferedReader[3];
		BufferedReader readerPrb;
		String namesFile = "/home/nmalhis/Desktop/1000Genomes/names1000";
		String fName;
		String[][] dataLine = new String[2][4];
		String[] s = new String[2];
		String prbFile;
		String prbLine;
		try {
			BufferedReader readerNames = new BufferedReader(new FileReader(namesFile));
			while (readerNames.ready()) {
				fName = readerNames.readLine();
				System.err.println(fName);
				prbFile = "/projects/nmalhis/PRBs/1000G/l/" + fName + ".prb.txt.gz";
				s[0] = "/projects/nmalhis/PRBs/1000G/fastq/" + fName + ".recal_mate" + 1 + ".fastq";
				s[1] = "/projects/nmalhis/PRBs/1000G/fastq/" + fName + ".recal_mate" + 2 + ".fastq";
				System.err.println(s[0] + "\n" + s[1]);
				Thread.sleep(1000);
    			if ((prbFile).indexOf(".gz") >= 0) {
    				readerPrb = new BufferedReader(new InputStreamReader(new GZIPInputStream(new FileInputStream(prbFile))));			
    			} else {
    				readerPrb = new BufferedReader(new InputStreamReader(new FileInputStream(prbFile)));
    			}
				reader[0] = new BufferedReader(new FileReader(s[0]));
				reader[1] = new BufferedReader(new FileReader(s[1]));
				while (reader[0].ready() && reader[1].ready() && readerPrb.ready()) {
					prbLine = readerPrb.readLine();
					for (int i = 0; i < 4; i++) {
						dataLine[0][i] = reader[0].readLine();
						dataLine[1][i] = reader[1].readLine();
					}
					System.err.println(dataLine[0][0]);
					System.err.println(dataLine[1][0] + "\n");
				}
				reader[0].close();
				reader[1].close();
			}
			readerNames.close();
		} catch (Exception e) {
			System.err.println("Error:\t" + e);
		}

	}

}
