// package JavaCode;

import java.io.File;

/*
SLIDER: Local Short Reads DNA Sequence Alignment
Beta Release; Ver 0.1, 22th Mar. 2008
By: Nawar Malhis
Canada's Michael Smith Genome Sciences Centre
*/

public class ScorePRB {
	static ReferenceSequences rs;
	
	// static final String    pathOut = "/projects/nmalhis/files/T0218D12/"; 

	public static void main(String[] args) throws Exception {
		int ux = 0;
		ReferenceSequences.ux = ux;
		
		if (args.length >= 1) {
			Parameters.read(args[0]);
			Parameters.resetTime();
			ReferenceSequences.display = false;
			// Oligo.nou = 2;
			rs = new ReferenceSequences();
			Oligo.fillCode();
			if (Parameters.skipCycles < 0) {
				Parameters.skipValue = true;
			} else {
				Parameters.skipValue = false;
			}
			if(!(new File(Parameters.pathData)).mkdir()) {
				System.err.println("Error creating the directory " + Parameters.pathData);
			}

			rs.statMPS(Parameters.pathPRB);

			System.err.print("\nTotal Execution time is: ");
			Parameters.printTime(Parameters.numberOfTimePoints - 1);
			System.err.println();
		} else {
			System.err.println("Please supply a configuration file");
			return;
		}
	}	

}
